<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 3</h1>
    <a>Ejercicio 6</a>

    <script>

    class Refugio {
        constructor() {
            this.perros = [];
            this.gatos  = [];
        }

        pushPerro(element) {
                this.perros.push(element);
                return this.perros;
        }

        pushGato(element) {
                this.gatos.push(element);
                return this.gatos;
        }

        popAny() {
            if (this.gatos.length === 0) {
                console.info("Fueron adoptados todos los gatos");
                if (this.perros.length === 0) {
                    console.info("Fueron adoptados todos los perros");
                } else {
                    this.perros = this.perros.reverse();
                    let adoptado = this.perros.pop(); 
                    console.log(`Usted adopto a ${adoptado}`);                  
                }
            } else {
                this.gatos = this.gatos.reverse();
                let adoptado = this.gatos.pop(); 
                console.log(`Usted adopto a ${adoptado}`); 
            }
        }

        popPerro() {
            if (this.perros.length != 0){
                this.perros = this.perros.reverse();
                let adoptado = this.perros.pop();
                console.log(`Usted adopto a "${adoptado}"`);
                this.perros = this.perros.reverse();                
            } else {
                console.error("Lo sentimos no hay perros que adoptar")
            }
        }

        popGato() {
            if (this.gatos.length != 0){
                this.gatos = this.gatos.reverse();
                let adoptado = this.gatos.pop();
                console.log(`Usted adopto a "${adoptado}"`);
                this.gatos = this.gatos.reverse();                
            } else {
                console.error("Lo sentimos no hay Gatos que adoptar")
            }
        }

        print() {
            console.log(`-----------------------------------------`);
            if (this.perros.length === 0) {
                console.log(`Todos los perros fueron adoptados`);
            } else {
                console.log(`Perros en Adopción: ${this.perros}`);
            }
            if (this.gatos.length === 0) {
                console.log(`Todos los gatos fueron adoptados`);
            } else {
                console.log(`Gatos en Adopción: ${this.gatos}`);
            }
            console.log(`------------------------------------------`);
        }
    }


    let mascota = new Refugio();
    mascota.pushPerro("Firulais");
    mascota.pushPerro("Castor");
    mascota.pushGato("Kika");
    mascota.pushGato("Blanca");
    mascota.pushGato("Sombra");
    mascota.print();
    mascota.popPerro();
    mascota.popGato();
    mascota.popAny();
    mascota.print();


    </script>
    
</body>
</html>